#!/usr/bin/perl -w

use strict;
use Data::Dumper;
use Getopt::Std;
use Storable qw(dclone);

use vars qw ($opt_h $opt_v);
&getopts('hv:');

my $usage = <<_EOH_;

## Options ###########################################
## Required:
# -v   release version of Ensembl genome browser

## Others:
# -h   print help

_EOH_
    ;

# Get input parameters from command line
die $usage if $opt_h;
my $version = $opt_v or die $usage;

# Get a list of the organism names from the Ensembl ftp site
my $tmpfile = 'orglist_ensembl.release-'.$version.".".$$;
my $enspath = "ftp://ftp.ensembl.org/pub/"
    . 'release-' . $version . '/'
    . 'fasta/';
my $cmd = 'ftp ' . $enspath . '> ' . $tmpfile . ' << _EOF_' . "\n"
    . 'ls' . "\n"
    . 'bye' . "\n"
    . '_EOF_' . "\n";
print STDERR "Connecting to " . $enspath . "...\n";
system($cmd);

# Print a list of the organism names obtained from the Ensembl ftp site
open(IN, $tmpfile) or die "Can't open $tmpfile to read.";
my $orgID = 0;
print '------ ------------------------------------------' . "\n"
    . ' ID     organism name'                             . "\n"
    . '------ ------------------------------------------' . "\n";
while(<IN>){
    chomp;
    if(/ftpuser/){
	my @cols = split(" ", $_);
	print ++$orgID . "\t" . $cols[-1] . "\n";
    }
}
close IN;
system("rm $tmpfile");
