// *************************************************************************
//  file.cpp
// *************************************************************************

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "osfinder.h"

// *************************************************************************
// read anchors.
void get_anc( std::vector<block> &anc_set, char* anc_file, int num_org ){
  char tmp_str[N_STR];
  block tmp_anc;
  int counter = 0;

  std::ifstream fin( anc_file );
  if( !fin ){
    std::cerr << " ! " << anc_file << " cannot open.\n";
    exit( -1 );
  }

  while( !fin.eof() ){
    fin >> tmp_str;
    switch( counter % FOUR ){
    case 0:
      tmp_anc.chrom_id[ (counter % (num_org*FOUR)) / FOUR ] = atoi( tmp_str );
    case 1:
      tmp_anc.start[ (counter % (num_org*FOUR)) / FOUR ] = atoi( tmp_str );
      break;
    case 2:
      tmp_anc.end[ (counter % (num_org*FOUR)) / FOUR ] = atoi( tmp_str );
      break;
    case 3:
      if( !(tmp_str[0] == '+' || tmp_str[0] == '-') ){
	std::cerr << " !! Error while reading anchor file." << std::endl;
	std::cerr << " !! Anchor file format or number of organisms is not appropriate for this program." << std::endl;
	exit( -1 );
      }
      tmp_anc.sign[ (counter % (num_org*FOUR)) / FOUR ] = tmp_str[0];
      break;
    default:
      break;
    }
    counter++;
    if( counter % ( num_org * FOUR ) == 0 ){
      anc_set.push_back( tmp_anc );
    }
  }

  fin.close();
}


// *************************************************************************
// calculate score of anchors.
/*
void cal_anc_scr( std::vector<block>& anc_set, double match_scr, int num_org ){
  for( int i=0 ; i<(int)anc_set.size() ; i++ ){
    anc_set[i].algn_scr = 0.0;
    for( int j=0 ; j<num_org ; j++ ){
      anc_set[i].algn_scr += (double)( anc_set[i].end[j] - anc_set[i].start[j] + 1 ) * match_scr;
    }
    anc_set[i].m_scr = anc_set[i].algn_scr;
  }
}
*/
